import { ClientConfig } from './createClient.js';
import { BatchRequestData, RequestData } from './types/RequestData.js';
import { IntegroPromise } from './utils/createIntegroPromise.js';
export type BatchPostOptions = {
    url: string;
    config: ClientConfig;
    data: BatchRequestData;
};
export type BatchedPromise<T extends readonly Promise<unknown>[] | [], Type extends Exclude<RequestData['type'], 'request'>> = IntegroPromise<{
    -readonly [P in keyof T]: Type extends 'all' | 'allSequential' ? Awaited<T[P]> : PromiseSettledResult<Awaited<T[P]>>;
}, [BatchPostOptions]> & [...{
    -readonly [P in keyof T]: IntegroPromise<Awaited<T[P]>>;
}, () => BatchedPromise<T, Type>];
export declare const all: <T extends [] | readonly Promise<unknown>[]>(promises: T) => BatchedPromise<T, "all">;
export declare const allSequential: <T extends [] | readonly Promise<unknown>[]>(promises: T) => BatchedPromise<T, "allSequential">;
export declare const allSettled: <T extends [] | readonly Promise<unknown>[]>(promises: T) => BatchedPromise<T, "allSettled">;
export declare const allSettledSequential: <T extends [] | readonly Promise<unknown>[]>(promises: T) => BatchedPromise<T, "allSettledSequential">;
